View Issue Details

IDProjectCategoryView StatusLast Update
0002912Far ManagerDialogpublic2015-01-22 04:13
Reporter2useven10Assigned Tozg 
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
Product Version 
Target VersionFixed in Version3.0 
Summary0002912: В диалогах DM_SETTEXT, DM_GETTEXT не позволяют работать со строками содержащими '\0'
DescriptionВ обработчиках упомянутых сообщений строки усекаются до первого '\0'.
Сообщения работают с DialogItemData, в котором есть указатель и длина строки.
Внутри диалога строка хранится в string, т.е. корректная работа с такими строками возможна.
Additional InformationСкорее всего, кроме правки обработчиков, надо будет править и редактор.
Первый вопрос: насколько серьёзны будут последствия исправления этих обработчиков?
Если многие используют текущее поведение как 'фичу' (некорректно задают длину текста), то может быть проще добавить новые сообщения, чтобы не было проблем с совместимостью.
TagsNo tags attached.
Build4250

Activities

shmuel

2015-01-19 18:28

developer   bugnote:0013418

Вроде как сами названия DM_SETTEXT, DM_GETTEXT предполагают текст, а не бинарные данные?

2useven10

2015-01-19 18:59

developer   bugnote:0013419

Текстовый редактор фар с такими строками работает.

shmuel

2015-01-19 19:14

developer   bugnote:0013420

В диалогах для ввода бинарных данных обычно применяют hex-формат.

Я не против, чтобы можно было вводить всё, что угодно, просто в моей практике написания плагинов такой потребности не возникало (там, где возникала, использовал hex, что, по-моему, нагляднее).

zg

2015-01-20 04:20

developer   bugnote:0013421

4248.

2useven10

2015-01-20 11:39

developer   bugnote:0013423

работает

shmuel

2015-01-20 21:02

developer   bugnote:0013424

Last edited: 2015-01-20 21:09

View 2 revisions

А как это видно, что работает?
Я (в Lua-скрипте) попробовал установить поле в значение "foo\0bar", по крайней мере визуально, получается "foo".

Update: ложная тревога, пробовал на старой версии.

zg

2015-01-21 00:13

developer   bugnote:0013425

4250.

Issue History

Date Modified Username Field Change
2015-01-19 17:01 2useven10 New Issue
2015-01-19 17:18 2useven10 Additional Information Updated View Revisions
2015-01-19 17:19 2useven10 Additional Information Updated View Revisions
2015-01-19 18:28 shmuel Note Added: 0013418
2015-01-19 18:59 2useven10 Note Added: 0013419
2015-01-19 19:14 shmuel Note Added: 0013420
2015-01-20 04:20 zg Note Added: 0013421
2015-01-20 11:39 2useven10 Note Added: 0013423
2015-01-20 11:39 2useven10 Assigned To => zg
2015-01-20 11:39 2useven10 Status new => resolved
2015-01-20 21:02 shmuel Note Added: 0013424
2015-01-20 21:09 shmuel Note Edited: 0013424 View Revisions
2015-01-21 00:13 zg Note Added: 0013425
2015-01-22 04:13 zg Build => 4250
2015-01-22 04:13 zg Status resolved => closed
2015-01-22 04:13 zg Resolution open => fixed
2015-01-22 04:13 zg Fixed in Version => 3.0